let oGen={freq1:0.5,freq2:0.5};
let tGeno=[];
let tGraph=[];

oGen.changeNomAll=function (force) {
	vMod.nomAll1=inputNomAllele1.value;
	vMod.nomAll2=inputNomAllele2.value;
	spanGeno1.innerHTML=vMod.nomAll1+"//"+vMod.nomAll1;
	spanGeno2.innerHTML=vMod.nomAll1+"//"+vMod.nomAll2;
	spanGeno3.innerHTML=vMod.nomAll2+"//"+vMod.nomAll2;
	spanNomMut1.innerHTML=vMod.nomAll1+" → "+vMod.nomAll2;
	spanNomMut2.innerHTML=vMod.nomAll2+" → "+vMod.nomAll1;
	if (force) {
		oGraph.trace();
	}
}

oGen.changeFreq0 = function () {
	vMod.freq0All1=inputFreq0.value*1;
}

oGen.initGeno = function () {
	tGeno=[];
	let nAll=vMod.eff*2;
	let nAll1=Math.round(nAll*vMod.freq0All1);
	let tAll0=[];
	for (let i=0;i<nAll1;i++) {
		tAll0.push(0);
	}
	for (let i=nAll1;i<nAll;i++) {
		tAll0.push(1);
	}
	for (let i=0;i<vMod.eff;i++) {
		let n1=Math.floor(tAll0.length*Math.random());
		let a1=tAll0[n1];
		tAll0.splice(n1, 1);
		let n2=Math.floor(tAll0.length*Math.random());
		let a2=tAll0[n2];	
		tAll0.splice(n2, 1);		
		tGeno.push([a1,a2]);
	}
}

oGen.calculeFreq = function () {
	if (vMod.eff==0) {return false}
	if (tGeno.length==0) {return false}
	let n1=0;
	let n2=0;
	for (let g of tGeno) {
		if (g[0]==0) {n1++} else {n2++}
		if (g[1]==0) {n1++} else {n2++}
	}
	oGen.freq1=n1/tGeno.length/2;
	oGen.freq2=n2/tGeno.length/2;
}

oGen.calculeNextGen = function () {
	if (tGeno.length==0) {return false}
	let tGeno2=[];
	let nbParents=tGeno.length;
	for (let i=0;i<vMod.eff;i++) {
		let np1=Math.floor(nbParents*Math.random());
		let np2=Math.floor(nbParents*Math.random());
		let na1=Math.floor(Math.random()*2);
		let na2=Math.floor(Math.random()*2);
		let a1=tGeno[np1][na1];
		let a2=tGeno[np2][na2];
		tGeno2.push([a1,a2]);
	}
	tGeno=JSON.parse(JSON.stringify(tGeno2));
}

oGen.appliqueMutations = function () {
	if (tGeno.length==0) {return false}
	if ((vMod.fMut1==0)&&(vMod.fMut2==0)) {return false}
	for (let i=0;i<vMod.eff;i++) {
		for (let j=0;j<2;j++) {
			if ((tGeno[i][j]==0)&&(vMod.fMut1>0)) {
				// mutation A=>B
				if (Math.random()<vMod.fMut1) {
					tGeno[i][j]=1;
				}
			} else {
				// mutation B=>A
				if (Math.random()<vMod.fMut2) {
					tGeno[i][j]=0;
				}
			}
		} 
	}
}

oGen.appliqueSurvie = function () {
	if (tGeno.length==0) {return false}
	if ((vMod.fit[0]==1)&&(vMod.fit[1]==1)&&(vMod.fit[2]==1)) {return false}
	let tGeno2=[];
	for (let i=0;i<vMod.eff;i++) {
		let g=tGeno[i][0]+tGeno[i][1];
		let f=vMod.fit[g];
		if (Math.random()<f) {
			// survie
			tGeno2.push(tGeno[i]);
		}
	}
	tGeno=JSON.parse(JSON.stringify(tGeno2));
}