oFile={}

oFile.exportCourbes = function () {
	let txt="";
	txt+="Génération;";
	for (let i=0;i<tGraph.length;i++) {
		txt+="Courbe "+i+";";
	}
	txt+="\n";
	for (let j=0;j<vMod.nGen;j++) {
		txt+=j+";";
		for (let i=0;i<tGraph.length;i++) {
			txt+=virg(tGraph[i][j])+";";
		}
		txt+="\n";
	}
	let BOM = "\uFEFF";
	let csvData = BOM + txt;
	let blob = new Blob([csvData], {type: "text/csv;charset=utf-8"});
	saveAs(blob, "courbes.csv");
}

oFile.exportModele = function () {
	let txt=JSON.stringify(vMod);
	let blob = new Blob([txt], {type: "text/csv;charset=utf-8"});
	saveAs(blob, "monModele.json");
}

oFile.importModele = function () {
	var file=fileinput.files[0];
	if (typeof(file)==="undefined") {return false}
	var filename=file.name;
	var reader  = new FileReader();
	reader.fn=filename;
	reader.addEventListener("load", function () {
		let txt=reader.result;
		vMod=JSON.parse(txt);
		oMod.init();
	}, false);
	
	reader.onerror = function () {
			console.log ("Erreur");
	}

	if (file) {
		reader.readAsText(file);
	}	
}