let oInf={fAA:0.25,fAB:0.5,fBB:0.25}

oInf.initGeno=function () {
	oGen.freq1=vMod.freq0All1;
	oInf.appliqueHW();
}

oInf.appliqueHW = function () {
	let p=oGen.freq1;
	let q=1-oGen.freq1;	
	oInf.fAA=p*p;
	oInf.fAB=2*p*q;
	oInf.fBB=q*q;
}

oInf.calcFreqAll = function  () {
	oGen.freq1=oInf.fAA+oInf.fAB/2;
}

oInf.calculeNextGen = function () {
	oInf.appliqueHW();
	oInf.appliqueMutations();
	oInf.appliqueSurvie();
}

oInf.appliqueSurvie = function () {
	oInf.fAA=oInf.fAA*vMod.fit[0];
	oInf.fAB=oInf.fAB*vMod.fit[1];
	oInf.fBB=oInf.fBB*vMod.fit[2];
	let tot=oInf.fAA+oInf.fAB+oInf.fBB;
	oInf.fAA=oInf.fAA/tot;
	oInf.fAB=oInf.fAB/tot;
	oInf.fBB=oInf.fBB/tot;
	oInf.calcFreqAll();
}

oInf.appliqueMutations = function () {
	let p=oGen.freq1;
	let q=1-oGen.freq1;	
	
	let nA=p;
	let nB=q;
	
	let newA=nB*vMod.fMut2;
	let newB=nA*vMod.fMut1;
	
	nA+=newA;
	nB-=newA;
	nB+=newB;
	nA-=newB;
	
	oGen.freq1=nA;
	oInf.appliqueHW();
}