let oMod={nbMaxGen:10000}

let vMod0={nGen:100,eff:100,nomAll1:"A",nomAll2:"B",freq0All1:0.5,nbMaxCourbes:10,fMut1:0,fMut2:0,fit:[1,1,1]}

let vMod=JSON.parse(JSON.stringify(vMod0));

oMod.reinit = function () {
	let url0="https://cosphilog.fr/genepop/";
	if (oDem.domaine=="localhost") {
		url0="http://localhost:82/genepop/app/";
	} else if (oDem.domaine=="nice") {
		url0="https://www.pedagogie.ac-nice.fr/svt/productions/genepop/";
	}
	if (window.history.replaceState) {
		window.history.pushState("index", "Gene'pop", url0);
	}
	vMod=JSON.parse(JSON.stringify(vMod0));
	oMod.init();
}

oMod.init = function () {
	inputNGen.max=oMod.nbMaxGen;
	inputFitAA.value=vMod.fit[0];
	inputFitAB.value=vMod.fit[1];
	inputFitBB.value=vMod.fit[2];
	inputFreqMut1.value=vMod.fMut1;
	inputFreqMut2.value=vMod.fMut2;
	inputNGen.value=vMod.nGen;
	inputEff.value=vMod.eff;
	inputNbMaxCourbes.value=vMod.nbMaxCourbes;
	inputNomAllele1.value=vMod.nomAll1;
	inputNomAllele2.value=vMod.nomAll2;
	inputFreq0.value=vMod.freq0All1;
	oGen.changeNomAll();
	oGraph.init();
}

oMod.changeFit = function () {
	if ((inputFitAA.value*1)<0) {inputFitAA.value=0}
	if ((inputFitAB.value*1)<0) {inputFitAB.value=0}
	if ((inputFitBB.value*1)<0) {inputFitBB.value=0}
	if ((inputFitAA.value*1)>1) {inputFitAA.value=1}
	if ((inputFitAB.value*1)>1) {inputFitAB.value=1}
	if ((inputFitBB.value*1)>1) {inputFitBB.value=1}
	vMod.fit[0]=inputFitAA.value*1;
	vMod.fit[1]=inputFitAB.value*1;
	vMod.fit[2]=inputFitBB.value*1;
}

oMod.changeMut = function () {
	if ((inputFreqMut1.value*1)>1) {inputFreqMut1.value=1}
	if ((inputFreqMut2.value*1)>1) {inputFreqMut2.value=1}
	vMod.fMut1=inputFreqMut1.value*1;
	vMod.fMut2=inputFreqMut2.value*1;
}

oMod.changeNGen = function () {
	if ((inputNGen.value*1)>oMod.nbMaxGen) {inputNGen.value=oMod.nbMaxGen}
	vMod.nGen=inputNGen.value*1;
	oGraph.init();
}

oMod.changeEff = function () {
	if ((inputEff.value*1)<0) {inputEff.value=0}
	if ((inputEff.value*1)>5000) {inputEff.value=5000}
	vMod.eff=inputEff.value*1;
}

oMod.changeNbMaxCourbes = function () {
	if ((inputNbMaxCourbes.value*1)>50) {inputNbMaxCourbes.value=50}
	vMod.nbMaxCourbes=inputNbMaxCourbes.value*1;
}

oMod.run = function () {
	tGraph[oGraph.i]=[];
	if (vMod.eff>0) {
		oGen.initGeno();
		oGen.calculeFreq();
	} else {
		oInf.initGeno();
	}
	for (let i=0;i<vMod.nGen;i++) {
		oGraph.store();
		if (vMod.eff>0) {
			oGen.calculeNextGen();
			oGen.appliqueMutations ();
			oGen.appliqueSurvie ();
			oGen.calculeFreq();
		} else {
			oInf.calculeNextGen();
		}
	}
		
	oGraph.store();
	oGraph.trace();	
	oGraph.i++;
	if (oGraph.i>=vMod.nbMaxCourbes) {oGraph.i=0}
}